## trust-store 1.1.0+14.10.20141015

=== src/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

find_package(Qt5Core REQUIRED)
find_package(Qt5Qml REQUIRED)
find_package(Qt5Quick REQUIRED)

pkg_check_modules(DBUS_CPP dbus-cpp REQUIRED)
pkg_check_modules(DBUS dbus-1 REQUIRED)
pkg_check_modules(LIBAPPARMOR libapparmor REQUIRED)
pkg_check_modules(SQLITE3 sqlite3 REQUIRED)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

include_directories(
  ${DBUS_CPP_INCLUDE_DIRS}
  ${DBUS_INCLUDE_DIRS}
  ${LIBAPPARMOR_INCLUDE_DIRS}
  ${SQLITE3_INCLUDE_DIRS}
)

set(
  TRUST_STORE_AGENT_SOURCES

  # Translation helper
  core/trust/i18n.h
  core/trust/i18n.cpp

  # An agent-implementation transforming ensuring legible application ids.
  core/trust/app_id_formatting_trust_agent.h
  core/trust/app_id_formatting_trust_agent.cpp

  # An agent-implementation that allows for selectively whitelisting app ids
  core/trust/white_listing_agent.cpp
  # An agent-implementation using a store instance to cache user replies.
  core/trust/cached_agent.cpp
  core/trust/cached_agent_glog_reporter.cpp

  # Agent implementations for handling request out of process.
  core/trust/remote/agent.h
  core/trust/remote/agent.cpp
  core/trust/remote/helpers.h
  core/trust/remote/helpers.cpp
  # An implementation relying on dbus
  core/trust/remote/dbus.h
  core/trust/remote/dbus.cpp
  # An implementation relying on unix sockets, to be used for
  # inclusion with the android Camera Service.
  core/trust/remote/posix.h
  core/trust/remote/posix.cpp
)

if (TRUST_STORE_MIR_AGENT_ENABLED)
  set(
    TRUST_STORE_AGENT_SOURCES ${TRUST_STORE_AGENT_SOURCES}
    # An agent-implementation leveraging Mir's trusted prompting support
    # to prompt the user for trusting an application to access a trusted
    # system service.
    core/trust/mir/agent.cpp
  )

  # Make sure Qt does not inject evil macros like 'signals' and 'slots'.
  add_definitions(-DQT_NO_KEYWORDS)
  # We need this for building the Qt-based prompt UI
  set(CMAKE_AUTOMOC ON)

  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/core/trust/mir/config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/core/trust/mir/config.h @ONLY)

  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/core/trust/mir/prompt_config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/core/trust/mir/prompt_config.h @ONLY)

  include_directories(${CMAKE_CURRENT_BINARY_DIR}/core/trust/mir/)

  add_executable(
    trust-prompt

    core/trust/mir/prompt_main.cpp
  )

  qt5_use_modules(trust-prompt Core Gui Qml Quick)

  target_link_libraries(
    trust-prompt

    ${Boost_LIBRARIES}
    ${PROCESS_CPP_LDFLAGS}
  )

  install(
    TARGETS trust-prompt
    RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )

  install(
    FILES core/trust/mir/prompt_main.qml
    DESTINATION ${CMAKE_INSTALL_DATADIR}/core/trust/mir
  )
else()
  set(
    TRUST_STORE_AGENT_SOURCES ${TRUST_STORE_AGENT_SOURCES}
    core/trust/mir/not_supported.cpp
  )
endif()

add_library(
  trust-store SHARED
  
  core/trust/agent.cpp
  core/trust/expose.cpp
  core/trust/request.cpp
  core/trust/resolve.cpp

  # All dbus-specific headers go here
  core/trust/dbus/agent.h
  core/trust/dbus/agent_registry.h
  core/trust/dbus/codec.h
  core/trust/dbus/interface.h

  # The default implementation leverages SQLite3 to persist
  # requests.
  core/trust/impl/sqlite3/store.cpp  

  # And pull in all our agent sources.
  ${TRUST_STORE_AGENT_SOURCES}
)

# Just a helper to avoid recompilation of the daemon
add_library(
  trust-stored

  core/trust/daemon.cpp
)

add_executable(
  trust-stored-skeleton

  core/trust/daemon_skeleton_main.cpp
)

add_executable(
  trust-stored-stub

  core/trust/daemon_stub_main.cpp
)

add_library(
  trust-store-preseed-helper

  core/trust/preseed.h
  core/trust/preseed.cpp
)

add_executable(
  trust-store-preseed

  core/trust/preseed_main.cpp
)

target_link_libraries(
  trust-store

  dbus-cpp

  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${GFLAGS_LDFLAGS}
  ${GLOG_LDFLAGS}
  ${LIBAPPARMOR_LDFLAGS}
  ${MIR_CLIENT_LDFLAGS}
  ${PROCESS_CPP_LDFLAGS}
  ${SQLITE3_LIBRARIES}
)

target_link_libraries(
  trust-stored

  trust-store

  ${MIR_CLIENT_LDFLAGS}
)

target_link_libraries(
  trust-stored-skeleton

  trust-stored
)

target_link_libraries(
  trust-stored-stub

  trust-stored
)

target_link_libraries(
  trust-store-preseed-helper

  trust-store
)

target_link_libraries(
  trust-store-preseed

  trust-store-preseed-helper
)

# We compile with all symbols visible by default. For the shipping library, we strip
# out all symbols that are not in core::trust::*
set(symbol_map "${CMAKE_SOURCE_DIR}/symbols.map")
set_target_properties(
  trust-store PROPERTIES
  LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
  LINK_DEPENDS ${symbol_map})

set_target_properties(
  trust-store

  PROPERTIES
  VERSION ${TRUST_STORE_VERSION_MAJOR}.${TRUST_STORE_VERSION_MINOR}.${TRUST_STORE_VERSION_PATCH}
  SOVERSION ${TRUST_STORE_VERSION_MAJOR}
)

install(
  TARGETS trust-store
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(
  TARGETS trust-stored-skeleton
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
  TARGETS trust-stored-stub
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
  TARGETS trust-store-preseed
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== tests/CMakeLists.txt ===
include_directories(${CMAKE_BINARY_DIR}/src)

# Build with system gmock and embedded gtest
set (GMOCK_INCLUDE_DIR "/usr/include/gmock/include" CACHE PATH "gmock source include directory")
set (GMOCK_SOURCE_DIR "/usr/src/gmock" CACHE PATH "gmock source directory")
set (GTEST_INCLUDE_DIR "${GMOCK_SOURCE_DIR}/gtest/include" CACHE PATH "gtest source include directory")

add_subdirectory(${GMOCK_SOURCE_DIR} "${CMAKE_CURRENT_BINARY_DIR}/gmock")

pkg_check_modules(DBUS dbus-1)

add_definitions(-DCORE_DBUS_ENABLE_GOOGLE_TEST_FIXTURE)

configure_file(test_data.h.in test_data.h @ONLY)

include_directories(
  ${CMAKE_SOURCE_DIR}/src

  ${CMAKE_CURRENT_BINARY_DIR}
  ${GMOCK_INCLUDE_DIR}
  ${GTEST_INCLUDE_DIR}
  ${PROCESS_CPP_INCLUDE_DIRS}
  ${DBUS_INCLUDE_DIRS}
)

add_executable(
  trust_store_test
  trust_store_test.cpp
)

add_executable(
  remote_trust_store_test
  remote_trust_store_test.cpp
)

add_executable(
  request_processor_test
  request_processor_test.cpp
)

add_executable(
  remote_agent_test
  remote_agent_test.cpp
)

add_executable(
  app_id_formatting_trust_agent_test
  app_id_formatting_trust_agent_test.cpp
)

add_executable(
  white_listing_agent_test
  white_listing_agent_test.cpp
)

add_executable(
  cached_agent_test
  cached_agent_test.cpp
)

add_executable(
  daemon_test
  daemon_test.cpp
)

add_executable(
  dbus_test
  dbus_test.cpp
)

add_executable(
  preseed_test
  preseed_test.cpp
)

target_link_libraries(
  trust_store_test

  trust-store

  gmock

  gtest
  gtest_main
)

target_link_libraries(
  remote_trust_store_test

  trust-store

  gmock

  gtest
  gtest_main

  ${PROCESS_CPP_LIBRARIES}
)

target_link_libraries(
  request_processor_test

  trust-store

  gmock

  gtest
  gtest_main

  ${PROCESS_CPP_LIBRARIES}
)

target_link_libraries(
  remote_agent_test

  trust-store

  gmock

  gtest
  gtest_main

  ${PROCESS_CPP_LIBRARIES}
)

target_link_libraries(
  app_id_formatting_trust_agent_test

  trust-store

  gmock

  gtest
  gtest_main

  ${PROCESS_CPP_LIBRARIES}
)

target_link_libraries(
  white_listing_agent_test

  trust-store

  gmock

  gtest
  gtest_main

  ${PROCESS_CPP_LIBRARIES}
)

target_link_libraries(
  cached_agent_test

  trust-store

  gmock

  gtest
  gtest_main

  ${PROCESS_CPP_LIBRARIES}
)

target_link_libraries(
  daemon_test

  trust-store
  trust-stored

  gmock

  gtest
  gtest_main

  ${PROCESS_CPP_LIBRARIES}
)

target_link_libraries(
  dbus_test

  trust-store

  gmock

  gtest
  gtest_main

  ${PROCESS_CPP_LIBRARIES}
)

target_link_libraries(
  preseed_test

  trust-store-preseed-helper

  gmock

  gtest
  gtest_main

  ${PROCESS_CPP_LIBRARIES}
)

add_test(trust_store_test ${CMAKE_CURRENT_BINARY_DIR}/trust_store_test)
add_test(remote_trust_store_test ${CMAKE_CURRENT_BINARY_DIR}/remote_trust_store_test)
add_test(request_processor_test ${CMAKE_CURRENT_BINARY_DIR}/request_processor_test)
add_test(remote_agent_test ${CMAKE_CURRENT_BINARY_DIR}/remote_agent_test)
add_test(app_id_formatting_trust_agent_test ${CMAKE_CURRENT_BINARY_DIR}/app_id_formatting_trust_agent_test)
add_test(cached_agent_test ${CMAKE_CURRENT_BINARY_DIR}/cached_agent_test)
add_test(white_listing_agent_test ${CMAKE_CURRENT_BINARY_DIR}/white_listing_agent_test)
# TODO(tvoss) Re-enable daemon tests once CI issues are resolved.
# add_test(daemon_test ${CMAKE_CURRENT_BINARY_DIR}/daemon_test)
add_test(dbus_test ${CMAKE_CURRENT_BINARY_DIR}/dbus_test)

install(
  TARGETS trust_store_test remote_trust_store_test request_processor_test remote_agent_test cached_agent_test daemon_test dbus_test
  RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR}/trust-store-tests
)

# Test setups relying on optional build dependencies go here
if (TRUST_STORE_MIR_AGENT_ENABLED)
  add_executable(
    mir_agent_test
    mir_agent_test.cpp
  )

  target_link_libraries(
    mir_agent_test

    trust-store

    gmock

    gtest
    gtest_main

    ${PROCESS_CPP_LIBRARIES}
  )

  add_test(mir_agent_test ${CMAKE_CURRENT_BINARY_DIR}/mir_agent_test --gtest_filter=*-*requires_mir)

  install(
    TARGETS mir_agent_test
    RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR}/trust-store-tests
  )
endif ()

=== debian/changelog ===
trust-store (1.1.0+14.10.20141015-0ubuntu1) utopic; urgency=low

  [ Ubuntu daily release ]
  * debian/libtrust-store1.symbols: auto-update to released version

  [ thomas-voss ]
  * Add an agent implementation that allows for selectively whitelisting
    certain apps. (LP: #1374577)
  * Do not prompt or cache accesses being issued by the camera app. (LP:
    #1374397)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Wed, 15 Oct 2014 18:23:41 +0000

trust-store (1.1.0+14.10.20141014.1-0ubuntu1) utopic; urgency=low

  [ thomas-voss ]
  * Make sure that the text domain is only adjusted if i18n is actually
    requested. (LP: #1380916)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Tue, 14 Oct 2014 09:16:35 +0000

trust-store (1.1.0+14.10.20141009-0ubuntu1) utopic; urgency=low

  [ Alberto Aguirre ]
  * Fix packaging issue due to some install files moving from libtrust-
    store1 to trust-store-bin

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 09 Oct 2014 19:28:10 +0000

trust-store (1.1.0+14.10.20141008.1-0ubuntu1) utopic; urgency=medium

  [ Thomas Voß ]
  * Add i18n support to the store.

  [ Ubuntu daily release ]
  * debian/libtrust-store1.symbols: auto-update to released version

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Wed, 08 Oct 2014 11:27:16 +0000

trust-store (1.0.0+14.10.20141006-0ubuntu1) utopic; urgency=low

  [ Alberto Aguirre ]
  * Attempt mir connection more than once (LP: #1377159)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 06 Oct 2014 16:36:29 +0000

trust-store (1.0.0+14.10.20141001-0ubuntu1) utopic; urgency=low

  [ Ubuntu daily release ]
  * debian/libtrust-store1.symbols: auto-update to released version
  * New rebuild forced

  [ thomas-voss ]
  * Throw on invalid mir connection or invalid prompt session. (LP:
    #1370444)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Wed, 01 Oct 2014 20:32:32 +0000

trust-store (1.0.0+14.10.20140826.1-0ubuntu1) utopic; urgency=low

  [ Ubuntu daily release ]
  * debian/libtrust-store1.symbols: auto-update to released version

  [ thomas-voss ]
  * Add an agent implementation that strips off version information, and
    leaves other information intact. (LP: #1356343)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Tue, 26 Aug 2014 15:11:18 +0000

trust-store (1.0.0+14.10.20140814.1-0ubuntu1) utopic; urgency=low

  [ Ubuntu daily release ]
  * debian/libtrust-store1.symbols: auto-update to released version

  [ thomas-voss ]
  * Add a reporter interface and a Google Log based implementation for
    core::trust::CachedAgent. (LP: #1354032)
  * Add a preseed helper and accompanying test.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 14 Aug 2014 13:23:05 +0000

trust-store (1.0.0+14.10.20140807-0ubuntu1) utopic; urgency=low

  [ thomas-voss ]
  * Remove unneeded build dependencies.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 07 Aug 2014 09:10:54 +0000

trust-store (1.0.0+14.10.20140806.7-0ubuntu1) utopic; urgency=low

  [ Ubuntu daily release ]
  * debian/libtrust-store1.symbols: auto-update to released version

  [ thomas-voss ]
  * Bail out in daemons if config and init stage fails. Add a simple
    shell to core::trust::Daemon::Stub for testing purposes. Add
    acceptance test for standalone service, in preparation for patches
    to the Android Camera Service. Add tagged integer types for Pid, Uid
    and Gid. Add test case to cover end-end scenarios for
    UnixDomainSocketRemoteAgent. Add a remote agent interface together
    with an implementation for unix domain sockets.
  * Leverage "PRAGMA user_version" to be able to handle upgrades in a
    future versoin. (LP: #1348481)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Wed, 06 Aug 2014 13:48:26 +0000

trust-store (1.0.0+14.10.20140725-0ubuntu1) utopic; urgency=low

  [ thomas-voss ]
  * Install test executables to CMAKE_INSTALL_LIBDIR instead of
    CMAKE_INSTALL_BINDIR. (LP: #1343533)
  * Install executor on internal session bus connection. (LP: #1347739)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 25 Jul 2014 09:22:46 +0000

trust-store (1.0.0+14.10.20140718.2-0ubuntu2) utopic; urgency=medium

  * Fix trust-store-tests dependency.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 22 Jul 2014 17:22:15 +0100

trust-store (1.0.0+14.10.20140718.2-0ubuntu1) utopic; urgency=medium

  [ Thomas Voß ]
  * Bump major revision and so name to account for toolchain update.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 18 Jul 2014 15:32:04 +0000

trust-store (0.0.1+14.10.20140717.8-0ubuntu1) utopic; urgency=low

  [ Ubuntu daily release ]
  * debian/*symbols: auto-update new symbols to released version

  [ thomas-voss ]
  * Provide an agent implementation that leverages Mir's trusted
    prompting API. Introduce a default prompt provider using Qt/QML.
    Provide a test harness around the core::trust::mir::Agent
    implementation and the prompt provider. Add a convenience function
    for processing incoming requests.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 17 Jul 2014 18:45:56 +0000

trust-store (0.0.1+14.10.20140717.1-0ubuntu1) utopic; urgency=low

  [ thomas-voss ]
  * Remove obsolete data/session.conf and data/system.conf files. Adjust
    directory creation default mode to 0755. (LP: #1338587)

  [ Ubuntu daily release ]
  * New rebuild forced

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 17 Jul 2014 08:52:11 +0000

trust-store (0.0.1+14.10.20140626.1-0ubuntu1) utopic; urgency=low

  [ Thomas Voß ]
  * Initial upload.

  [ Ubuntu daily release ]
  * debian/*symbols: auto-update new symbols to released version

  [ thomas-voss ]
  * Initial commit.
  * Added a packaging setup.
  * Added missing build-dep on pkg-config.
  * Added doxygen documentation to public-facing API. Refactored SQLite3


=== debian/control ===
Source: trust-store
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: cmake,
               debhelper (>= 9),
               doxygen,
               google-mock,
               graphviz,
# We rely on C++11 features, and to prevent from ABI breaks
# in libstdc++ causing us issues, we explicitly select a G++
# version.
               g++-4.9,
               libapparmor-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libdbus-cpp-dev (>= 4.0.0),
               libdbus-1-dev,
               libgflags-dev,
               libgoogle-glog-dev,
               libgtest-dev,
               libjson-c-dev,
               libmirclient-dev [amd64 arm64 i386 armhf],
               libprocess-cpp-dev,
               libsqlite3-dev,
               pkg-config,
               qt5-default,
               qtbase5-dev,
               qtdeclarative5-dev,
Standards-Version: 3.9.5
Section: libs
Homepage: https://launchpad.net/trust-store
# if you don't have have commit access to this branch but would like to upload
# directly to Ubuntu, don't worry: your changes will be merged back into the
# upstream branch
Vcs-Bzr: lp:trust-store

Package: libtrust-store1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: C++11 library for persisting trust requests - runtime library
 Provides a common implementation of a trust store to be used by trusted
 helpers.
 .
 This package includes the trust-store runtime libraries.

Package: libtrust-store-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Recommends: libtrust-store-doc,
Depends: libtrust-store1 (= ${binary:Version}),
         ${misc:Depends},
Description: C++11 library for persisting trust requests - dev files
 Provides a common implementation of a trust store to be used by trusted
 helpers.
 .
 This package includes all the development headers and libraries for
 trust-store.

Package: trust-store-bin
Section: devel
Architecture: any
Depends: libtrust-store1 (= ${binary:Version}),
         ${misc:Depends},
Replaces: libtrust-store1 (<< 1.1.0+14.10.20141008),
Breaks: libtrust-store1 (<< 1.1.0+14.10.20141008),
Description: Daemon binaries to be used by services.
 Provides a common implementation of a trust store to be used by trusted
 helpers.
 .
 Daemon binaries to be used by services.

Package: trust-store-tests
Section: libdevel
Architecture: any
Depends: libtrust-store1 (= ${binary:Version}),
         ${misc:Depends},
Suggests: libtrust-store-dev,
Description: Test files for libtrust-store1
 Provides a common implementation of a trust store to be used by trusted
 helpers.
 .
 This package includes test executables packaged for post-build execution.

Package: libtrust-store-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
Suggests: libtrust-store-dev,
Description: Documentation files for libtrust-store-dev
 Provides a common implementation of a trust store to be used by trusted
 helpers.
 .
 This package includes documentation files for developing with and for
 libtrust-store-dev.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

include /usr/share/dpkg/default.mk

# Explicitly selecting a G{CC,++}-version here to avoid accidental
# ABI breaks introduced by toolchain updates.
export CC=$(DEB_HOST_GNU_TYPE)-gcc-4.9
export CXX=$(DEB_HOST_GNU_TYPE)-g++-4.9

# Mir is an optional build dependency
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 arm64 i386 armhf))
        TRUST_STORE_MIR_AGENT_ENABLED = ON
else
        TRUST_STORE_MIR_AGENT_ENABLED = OFF
endif

# The home directory of user buildd does not exist on the builders
export XDG_DATA_HOME=/tmp

%:
	dh $@ --fail-missing

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_C_COMPILER=$(CC) -DCMAKE_CXX_COMPILER=$(CXX) -DTRUST_STORE_MIR_AGENT_ENABLED=$(TRUST_STORE_MIR_AGENT_ENABLED)

## trust-store 1.1.0+15.04.20141107.1

=== debian/changelog ===
trust-store (1.1.0+15.04.20141107.1-0ubuntu1) vivid; urgency=low

  [ thomas-voss ]
  * Select correct gettext domain for the trust prompt. (LP: #1354092)

  [ Ubuntu daily release ]
  * New rebuild forced

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 07 Nov 2014 12:10:51 +0000

## trust-store 1.1.0+15.04.20150123

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(trust-store)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(cmake/EnableCoverageReport.cmake)
include(cmake/PrePush.cmake)
include(GNUInstallDirs)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror -Wall -pedantic -Wextra -fPIC -fvisibility=hidden -pthread")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Werror -Wall -fno-strict-aliasing -fvisibility=hidden -fvisibility-inlines-hidden -pedantic -Wextra -fPIC -pthread")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")

#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
IF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])

find_package(PkgConfig)
find_package(Boost COMPONENTS program_options system REQUIRED)

option(
  TRUST_STORE_MIR_AGENT_ENABLED
  "Enables a local agent implementation relying on Mir's trusted prompting"
  ON)

if (TRUST_STORE_MIR_AGENT_ENABLED)
  pkg_check_modules(MIR_CLIENT mirclient REQUIRED)

  include_directories(
    ${MIR_CLIENT_INCLUDE_DIRS}
  )
endif()

pkg_check_modules(GFLAGS libgflags REQUIRED)
pkg_check_modules(GLOG libglog REQUIRED)
pkg_check_modules(PROCESS_CPP process-cpp REQUIRED)

set(TRUST_STORE_VERSION_MAJOR 1)
set(TRUST_STORE_VERSION_MINOR 1)
set(TRUST_STORE_VERSION_PATCH 0)

include(CTest)

include_directories(
  include/

  ${GFLAGS_INCLUDE_DIRS}
  ${GLOG_INCLUDE_DIRS}
  ${PROCESS_CPP_INCLUDE_DIRS}
)

add_subdirectory(doc)
add_subdirectory(data)
add_subdirectory(include)
add_subdirectory(po)
add_subdirectory(src)
add_subdirectory(tests)

enable_coverage_report(trust_store_test)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -90,6 +90,10 @@
   add_executable(
     trust-prompt
 
+    # Translation helper
+    core/trust/i18n.h
+    core/trust/i18n.cpp
+
     core/trust/mir/prompt_main.cpp
   )

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -24,6 +24,11 @@
 )
 
 add_executable(
+  bug_1387734
+  bug_1387734.cpp
+)
+
+add_executable(
   trust_store_test
   trust_store_test.cpp
 )
@@ -74,6 +79,17 @@
 )
 
 target_link_libraries(
+  bug_1387734
+
+  trust-store
+
+  gmock
+
+  gtest
+  gtest_main
+)
+
+target_link_libraries(
   trust_store_test
 
   trust-store
@@ -202,6 +218,7 @@
   ${PROCESS_CPP_LIBRARIES}
 )
 
+add_test(bug_1387734 ${CMAKE_CURRENT_BINARY_DIR}/bug_1387734)
 add_test(trust_store_test ${CMAKE_CURRENT_BINARY_DIR}/trust_store_test)
 add_test(remote_trust_store_test ${CMAKE_CURRENT_BINARY_DIR}/remote_trust_store_test)
 add_test(request_processor_test ${CMAKE_CURRENT_BINARY_DIR}/request_processor_test)

=== debian/changelog ===
trust-store (1.1.0+15.04.20150123-0ubuntu1) vivid; urgency=low

  [ thomas-voss ]
  * Make sure that cached trust requests are sorted by their timestamp
    in descending order. Add regression test case. (LP: #1387734)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 23 Jan 2015 09:56:00 +0000

## trust-store 1.1.0+15.04.20150213

=== debian/changelog ===
trust-store (1.1.0+15.04.20150213-0ubuntu1) vivid; urgency=medium

  [ thomas-voss ]
  * Add support for enabling the testability driver for the trust
    prompt. (LP: #1420790)

 -- CI Train Bot <ci-train-bot@canonical.com>  Fri, 13 Feb 2015 13:54:28 +0000

## trust-store 1.1.0+15.10.20150629

=== CMakeLists.txt ===
--- 
+++ 
@@ -43,7 +43,6 @@
   )
 endif()
 
-pkg_check_modules(GFLAGS libgflags REQUIRED)
 pkg_check_modules(GLOG libglog REQUIRED)
 pkg_check_modules(PROCESS_CPP process-cpp REQUIRED)
 
@@ -56,7 +55,6 @@
 include_directories(
   include/
 
-  ${GFLAGS_INCLUDE_DIRS}
   ${GLOG_INCLUDE_DIRS}
   ${PROCESS_CPP_INCLUDE_DIRS}
 )

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -183,7 +183,6 @@
 
   ${Boost_LIBRARIES}
   ${DBUS_LIBRARIES}
-  ${GFLAGS_LDFLAGS}
   ${GLOG_LDFLAGS}
   ${LIBAPPARMOR_LDFLAGS}
   ${MIR_CLIENT_LDFLAGS}

=== debian/changelog ===
trust-store (1.1.0+15.10.20150629-0ubuntu1) wily; urgency=medium

  [ Andreas Pokorny ]
  * Remove usage of mir_false make dependency to libmirclient-dev
    architecture independent, and remove unused libgflags dependency.
    removed: debian/trust-store-bin.install.amd64@ debian/trust-store-
    bin.install.arm64@ debian/trust-store-bin.install.armhf@
    debian/trust-store-bin.install.i386@ debian/trust-store-
    bin.install.with_mir

  [ CI Train Bot ]
  * Resync trunk. added: po/af.po po/bg.po po/eo.po po/et.po po/mk.po
    po/ny.po po/sk.po po/sq.po po/tg.po

 -- CI Train Bot <ci-train-bot@canonical.com>  Mon, 29 Jun 2015 05:00:16 +0000

=== debian/control ===
--- 
+++ 
@@ -15,11 +15,10 @@
                libboost-system-dev,
                libdbus-cpp-dev (>= 4.0.0),
                libdbus-1-dev,
-               libgflags-dev,
                libgoogle-glog-dev,
                libgtest-dev,
                libjson-c-dev,
-               libmirclient-dev [amd64 arm64 i386 armhf],
+               libmirclient-dev (>= 0.14.0),
                libprocess-cpp-dev,
                libsqlite3-dev,
                pkg-config,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

include /usr/share/dpkg/default.mk

# Explicitly selecting a G{CC,++}-version here to avoid accidental
# ABI breaks introduced by toolchain updates.
export CC=$(DEB_HOST_GNU_TYPE)-gcc-4.9
export CXX=$(DEB_HOST_GNU_TYPE)-g++-4.9

# The home directory of user buildd does not exist on the builders
export XDG_DATA_HOME=/tmp

%:
	dh $@ --fail-missing

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_C_COMPILER=$(CC) -DCMAKE_CXX_COMPILER=$(CXX) -DTRUST_STORE_MIR_AGENT_ENABLED=ON

## trust-store 2.0.0

=== debian/changelog ===
trust-store (2.0.0-0ubuntu1) wily; urgency=medium

  * Bump major revision to account for toolchain update. Fixes LP:#1452341

 -- Thomas Voß <thomas.voss@canonical.com>  Thu, 23 Jul 2015 09:22:15 +0200

## trust-store 2.0.0+15.10.20150831.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -46,8 +46,8 @@
 pkg_check_modules(GLOG libglog REQUIRED)
 pkg_check_modules(PROCESS_CPP process-cpp REQUIRED)
 
-set(TRUST_STORE_VERSION_MAJOR 1)
-set(TRUST_STORE_VERSION_MINOR 1)
+set(TRUST_STORE_VERSION_MAJOR 2)
+set(TRUST_STORE_VERSION_MINOR 0)
 set(TRUST_STORE_VERSION_PATCH 0)
 
 include(CTest)
@@ -55,6 +55,7 @@
 include_directories(
   include/
 
+  ${GFLAGS_INCLUDE_DIRS}
   ${GLOG_INCLUDE_DIRS}
   ${PROCESS_CPP_INCLUDE_DIRS}
 )

=== debian/changelog ===
trust-store (2.0.0+15.10.20150831.3-0ubuntu1) wily; urgency=medium

  [ Alfonso Sanchez-Beato (email Canonical) ]
  * Merge wily changes upstream

  [ CI Train Bot ]
  * No-change rebuild.

 -- CI Train Bot <ci-train-bot@canonical.com>  Mon, 31 Aug 2015 15:11:25 +0000

trust-store (1.1.0+15.04.20150820-0ubuntu1) vivid; urgency=medium

  [ Ken VanDine ]
  * localize string "<application> is trying to access <service>" (LP:
    #1487142)

 -- CI Train Bot <ci-train-bot@canonical.com>  Thu, 20 Aug 2015 18:19:04 +0000

trust-store (1.1.0+15.04.20150817-0ubuntu1) vivid; urgency=medium

  * Resync trunk. added: po/ku.po

 -- CI Train Bot <ci-train-bot@canonical.com>  Mon, 17 Aug 2015 07:58:45 +0000

trust-store (1.1.0+15.04.20150629-0ubuntu1) vivid; urgency=medium

  [ Andreas Pokorny ]
  * Remove usage of mir_false make dependency to libmirclient-dev
    architecture independent, and remove unused libgflags dependency.
    removed: debian/trust-store-bin.install.amd64@ debian/trust-store-
    bin.install.arm64@ debian/trust-store-bin.install.armhf@
    debian/trust-store-bin.install.i386@ debian/trust-store-
    bin.install.with_mir

  [ CI Train Bot ]
  * Resync trunk. added: po/af.po po/bg.po po/eo.po po/et.po po/mk.po
    po/ny.po po/sk.po po/sq.po po/tg.po

 -- CI Train Bot <ci-train-bot@canonical.com>  Mon, 29 Jun 2015 05:00:16 +0000

=== debian/control ===
--- 
+++ 
@@ -6,19 +6,16 @@
                doxygen,
                google-mock,
                graphviz,
-# We rely on C++11 features, and to prevent from ABI breaks
-# in libstdc++ causing us issues, we explicitly select a G++
-# version.
-               g++-4.9,
                libapparmor-dev,
                libboost-program-options-dev,
                libboost-system-dev,
                libdbus-cpp-dev (>= 4.0.0),
                libdbus-1-dev,
+               libgflags-dev,
                libgoogle-glog-dev,
                libgtest-dev,
                libjson-c-dev,
-               libmirclient-dev (>= 0.14.0),
+               libmirclient-dev [amd64 arm64 i386 armhf],
                libprocess-cpp-dev,
                libsqlite3-dev,
                pkg-config,
@@ -33,7 +30,7 @@
 # upstream branch
 Vcs-Bzr: lp:trust-store
 
-Package: libtrust-store1
+Package: libtrust-store2
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends},
@@ -51,7 +48,7 @@
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends},
 Recommends: libtrust-store-doc,
-Depends: libtrust-store1 (= ${binary:Version}),
+Depends: libtrust-store2 (= ${binary:Version}),
          ${misc:Depends},
 Description: C++11 library for persisting trust requests - dev files
  Provides a common implementation of a trust store to be used by trusted
@@ -63,10 +60,8 @@
 Package: trust-store-bin
 Section: devel
 Architecture: any
-Depends: libtrust-store1 (= ${binary:Version}),
+Depends: libtrust-store2 (= ${binary:Version}),
          ${misc:Depends},
-Replaces: libtrust-store1 (<< 1.1.0+14.10.20141008),
-Breaks: libtrust-store1 (<< 1.1.0+14.10.20141008),
 Description: Daemon binaries to be used by services.
  Provides a common implementation of a trust store to be used by trusted
  helpers.
@@ -76,7 +71,7 @@
 Package: trust-store-tests
 Section: libdevel
 Architecture: any
-Depends: libtrust-store1 (= ${binary:Version}),
+Depends: libtrust-store2 (= ${binary:Version}),
          ${misc:Depends},
 Suggests: libtrust-store-dev,
 Description: Test files for libtrust-store1

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

include /usr/share/dpkg/default.mk

# Mir is an optional build dependency
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 arm64 i386 armhf))
        TRUST_STORE_MIR_AGENT_ENABLED = ON
else
        TRUST_STORE_MIR_AGENT_ENABLED = OFF
endif

# The home directory of user buildd does not exist on the builders
export XDG_DATA_HOME=/tmp

%:
	dh $@ --fail-missing

override_dh_auto_configure:
	dh_auto_configure -- -DTRUST_STORE_MIR_AGENT_ENABLED=$(TRUST_STORE_MIR_AGENT_ENABLED)

## trust-store 2.0.0+16.04.20160119

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,37 @@
 cmake_minimum_required(VERSION 2.8)
 
 project(trust-store)
+
+# We haven't received version information via the packaging setup.
+# For that, we try to determine sensible values on our own, ensuring
+# plain old invocations to cmake still work as expected.
+if (NOT DEFINED TRUST_STORE_VERSION_MAJOR)
+  find_program(LSB_RELEASE lsb_release)
+  execute_process(
+    COMMAND ${LSB_RELEASE} -c -s
+    OUTPUT_VARIABLE DISTRO_CODENAME
+    OUTPUT_STRIP_TRAILING_WHITESPACE)
+
+  # We explicitly ignore errors and only check if we are building for vivid.
+  # For all other cases:
+  #   - releases other than vivid
+  #   - other distros
+  #   - errors
+  # we define the version to be 2.0.0
+  if (${DISTRO_CODENAME} STREQUAL "vivid")
+    set(TRUST_STORE_VERSION_MAJOR 1)
+    set(TRUST_STORE_VERSION_MINOR 1)
+    set(TRUST_STORE_VERSION_PATCH 0)
+  else ()
+    set(TRUST_STORE_VERSION_MAJOR 2)
+    set(TRUST_STORE_VERSION_MINOR 0)
+    set(TRUST_STORE_VERSION_PATCH 0)
+  endif()
+endif()
+
+message(STATUS "${CMAKE_PROJECT_NAME} ${TRUST_STORE_VERSION_MAJOR}.${TRUST_STORE_VERSION_MINOR}.${TRUST_STORE_VERSION_PATCH}")
+
+
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
 
@@ -28,7 +59,9 @@
 ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
 
 find_package(PkgConfig)
-find_package(Boost COMPONENTS program_options system REQUIRED)
+find_package(Boost COMPONENTS filesystem program_options system REQUIRED)
+
+add_subdirectory(3rd_party/xdg)
 
 option(
   TRUST_STORE_MIR_AGENT_ENABLED
@@ -46,14 +79,11 @@
 pkg_check_modules(GLOG libglog REQUIRED)
 pkg_check_modules(PROCESS_CPP process-cpp REQUIRED)
 
-set(TRUST_STORE_VERSION_MAJOR 2)
-set(TRUST_STORE_VERSION_MINOR 0)
-set(TRUST_STORE_VERSION_PATCH 0)
-
 include(CTest)
 
 include_directories(
   include/
+  3rd_party/xdg
 
   ${GFLAGS_INCLUDE_DIRS}
   ${GLOG_INCLUDE_DIRS}

=== data/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

configure_file(
  trust-store.pc.in trust-store.pc @ONLY
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/trust-store.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

=== doc/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

option(
  TRUST_STORE_ENABLE_DOC_GENERATION
  "Generate package documentation with doxygen"
  ON
)

if (TRUST_STORE_ENABLE_DOC_GENERATION)

find_package(Doxygen)

if (DOXYGEN_FOUND)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in 
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
  add_custom_target(doc ALL
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating API documentation with Doxygen" VERBATIM)
  install(
    DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
    DESTINATION ${CMAKE_INSTALL_DOCDIR})

endif (DOXYGEN_FOUND)
endif (TRUST_STORE_ENABLE_DOC_GENERATION)

=== po/CMakeLists.txt ===
include(FindGettext REQUIRED)
find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)

set(DOMAIN trust-store)
set(POT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/${DOMAIN}.pot)
file(GLOB PO_FILES *.po)

# We look through all source files and find
# usages of i18n::tr.
file(
    GLOB_RECURSE I18N_CPP_SRC_FILES
    ${CMAKE_SOURCE_DIR}/src/*.cpp ${CMAKE_SOURCE_DIR}/src/*.qml)

list(SORT I18N_CPP_SRC_FILES)

add_custom_target(
    trust-store-pot
    COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE}
        --default-domain=trust-store
        --output=${POT_FILE}
        --from-code=UTF-8
        --c++ --add-comments=TRANSLATORS
        --keyword='tr'
        --boost
        --package-name=trust-store
        --copyright-holder='Canonical Ltd.'
        ${I18N_CPP_SRC_FILES})

foreach(PO_FILE ${PO_FILES})
    get_filename_component(LANG ${PO_FILE} NAME_WE)
    gettext_process_po_files(${LANG} ALL PO_FILES ${PO_FILE})
    set(INSTALL_DIR ${CMAKE_INSTALL_LOCALEDIR}/${LANG}/LC_MESSAGES)
    install(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.gmo
        DESTINATION ${INSTALL_DIR}
        RENAME ${DOMAIN}.mo)
endforeach(PO_FILE)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -20,6 +20,8 @@
 
 pkg_check_modules(DBUS_CPP dbus-cpp REQUIRED)
 pkg_check_modules(DBUS dbus-1 REQUIRED)
+pkg_check_modules(GLIB glib-2.0 REQUIRED)
+pkg_check_modules(GOBJECT gobject-2.0 REQUIRED)
 pkg_check_modules(LIBAPPARMOR libapparmor REQUIRED)
 pkg_check_modules(SQLITE3 sqlite3 REQUIRED)
 
@@ -28,6 +30,8 @@
 include_directories(
   ${DBUS_CPP_INCLUDE_DIRS}
   ${DBUS_INCLUDE_DIRS}
+  ${GLIB_INCLUDE_DIRS}
+  ${GOBJECT_INCLUDE_DIRS}
   ${LIBAPPARMOR_INCLUDE_DIRS}
   ${SQLITE3_INCLUDE_DIRS}
 )
@@ -42,6 +46,9 @@
   # An agent-implementation transforming ensuring legible application ids.
   core/trust/app_id_formatting_trust_agent.h
   core/trust/app_id_formatting_trust_agent.cpp
+
+  # An agent implementation preventing privilege escalation attacks.
+  core/trust/privilege_escalation_prevention_agent.cpp
 
   # An agent-implementation that allows for selectively whitelisting app ids
   core/trust/white_listing_agent.cpp
@@ -70,6 +77,7 @@
     # to prompt the user for trusting an application to access a trusted
     # system service.
     core/trust/mir/agent.cpp
+    core/trust/mir/click_desktop_entry_app_info_resolver.cpp
   )
 
   # Make sure Qt does not inject evil macros like 'signals' and 'slots'.
@@ -129,10 +137,15 @@
   core/trust/expose.cpp
   core/trust/request.cpp
   core/trust/resolve.cpp
+  core/trust/runtime.h
+  core/trust/runtime.cpp
 
   # All dbus-specific headers go here
   core/trust/dbus/agent.h
+  core/trust/dbus/agent.cpp
   core/trust/dbus/agent_registry.h
+  core/trust/dbus/bus_factory.h
+  core/trust/dbus/bus_factory.cpp
   core/trust/dbus/codec.h
   core/trust/dbus/interface.h
 
@@ -149,6 +162,9 @@
   trust-stored
 
   core/trust/daemon.cpp
+
+  core/trust/runtime.h
+  core/trust/runtime.cpp
 )
 
 add_executable(
@@ -180,10 +196,14 @@
   trust-store
 
   dbus-cpp
+  xdg
 
   ${Boost_LIBRARIES}
   ${DBUS_LIBRARIES}
+  ${GFLAGS_LDFLAGS}
   ${GLOG_LDFLAGS}
+  ${GLIB_LDFLAGS}
+  ${GOBJECT_LDFLAGS}
   ${LIBAPPARMOR_LDFLAGS}
   ${MIR_CLIENT_LDFLAGS}
   ${PROCESS_CPP_LDFLAGS}

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -46,6 +46,9 @@
 add_executable(
   remote_agent_test
   remote_agent_test.cpp
+
+  ${CMAKE_SOURCE_DIR}/src/core/trust/runtime.h
+  ${CMAKE_SOURCE_DIR}/src/core/trust/runtime.cpp
 )
 
 add_executable(
@@ -59,6 +62,11 @@
 )
 
 add_executable(
+  privilege_escalation_prevention_agent_test
+  privilege_escalation_prevention_agent_test.cpp
+)
+
+add_executable(
   cached_agent_test
   cached_agent_test.cpp
 )
@@ -166,6 +174,20 @@
 )
 
 target_link_libraries(
+  privilege_escalation_prevention_agent_test
+
+  trust-store
+
+  gmock
+
+  gtest
+  gtest_main
+
+  ${PROCESS_CPP_LIBRARIES}
+)
+
+
+target_link_libraries(
   cached_agent_test
 
   trust-store
@@ -196,6 +218,7 @@
   dbus_test
 
   trust-store
+  trust-stored
 
   gmock
 
@@ -226,6 +249,7 @@
 add_test(app_id_formatting_trust_agent_test ${CMAKE_CURRENT_BINARY_DIR}/app_id_formatting_trust_agent_test)
 add_test(cached_agent_test ${CMAKE_CURRENT_BINARY_DIR}/cached_agent_test)
 add_test(white_listing_agent_test ${CMAKE_CURRENT_BINARY_DIR}/white_listing_agent_test)
+add_test(privilege_escalation_prevention_agent_test ${CMAKE_CURRENT_BINARY_DIR}/privilege_escalation_prevention_agent_test)
 # TODO(tvoss) Re-enable daemon tests once CI issues are resolved.
 # add_test(daemon_test ${CMAKE_CURRENT_BINARY_DIR}/daemon_test)
 add_test(dbus_test ${CMAKE_CURRENT_BINARY_DIR}/dbus_test)
@@ -242,10 +266,16 @@
     mir_agent_test.cpp
   )
 
+  add_executable(
+    click_desktop_entry_app_name_resolver_test
+    click_desktop_entry_app_name_resolver_test.cpp
+  )
+
   target_link_libraries(
     mir_agent_test
 
     trust-store
+    xdg
 
     gmock
 
@@ -255,7 +285,22 @@
     ${PROCESS_CPP_LIBRARIES}
   )
 
+  target_link_libraries(
+    click_desktop_entry_app_name_resolver_test
+
+    trust-store
+
+    gmock
+
+    gtest
+    gtest_main
+
+    ${PROCESS_CPP_LIBRARIES}
+  )
+
+
   add_test(mir_agent_test ${CMAKE_CURRENT_BINARY_DIR}/mir_agent_test --gtest_filter=*-*requires_mir)
+  add_test(click_desktop_entry_app_name_resolver_test ${CMAKE_CURRENT_BINARY_DIR}/click_desktop_entry_app_name_resolver_test)
 
   install(
     TARGETS mir_agent_test

=== 3rd_party/xdg/CMakeLists.txt ===
project(xdg)

cmake_minimum_required(VERSION 2.8)

find_package(Boost COMPONENTS filesystem system unit_test_framework)

include_directories(
    .
    ${Boost_INCLUDE_DIRS}
)

add_library(xdg xdg.cpp)
set_property(TARGET xdg PROPERTY CXX_STANDARD 11)
target_link_libraries(xdg ${Boost_LIBRARIES})

enable_testing()
add_definitions(-DBOOST_TEST_DYN_LINK -DBOOST_TEST_MAIN -DBOOST_TEST_MODULE=xdg)
add_executable(xdg_test xdg_test.cpp)
set_property(TARGET xdg_test PROPERTY CXX_STANDARD 11)
target_link_libraries(xdg_test xdg)

add_test(xdg_test xdg_test)

=== debian/changelog ===
trust-store (2.0.0+16.04.20160119-0ubuntu1) xenial; urgency=medium

  [ CI Train Bot ]
  * Resync trunk.

  [ Thomas Voß ]
  * Enable dual landing to vivid+o, and all later releases.
  * Merge core::trust::Runtime changes. Add better support for in-
    session service scenarios, with services likely being activated on
    demand. Add load test cases around in-session service scenario.

 -- Rodney Dawes <ci-train-bot@canonical.com>  Tue, 19 Jan 2016 15:22:52 +0000

trust-store (1.1.0+15.04.20160118.4-0ubuntu1) vivid; urgency=medium

  * Enable translations for vivid. (LP: #1532870)

 -- Thomas Voß <ci-train-bot@canonical.com>  Mon, 18 Jan 2016 20:35:42 +0000

trust-store (1.1.0+15.04.20160112-0ubuntu1) vivid; urgency=medium

  * Update pot file for trust-store. (LP: #1532870)

 -- Thomas Voß <ci-train-bot@canonical.com>  Tue, 12 Jan 2016 20:09:20 +0000

trust-store (1.1.0+15.04.20151211-0ubuntu1) vivid; urgency=medium

  [ CI Train Bot ]
  * Revert bump to major revision 2, vivid (+overlay) still has 1.1.0
    and gcc 4.9.

  [ Thomas Voß ]
  * Add a 3rd-party dependency on github.com/vosst/xdg.
  * Add interface mir::AppNameResolver. (LP: #1382610, #1504022)
  * Introduce a trust::PrivilegeEscalationPreventionAgent, filtering out
    invalid requests. Fixes lp:#1518883. (LP: #1518883)

 -- Thomas Voß <ci-train-bot@canonical.com>  Fri, 11 Dec 2015 08:58:16 +0000

trust-store (1.1.0+15.04.20151126-0ubuntu1) vivid; urgency=medium

  [ Thomas Voß ]
  * Revert bump to major revision 2, vivid (+overlay) still has
    1.1.0 and gcc 4.9. 

  [ CI Train Bot ]
  * New rebuild forced.
  * Resync trunk.

 -- Thomas Voß <ci-train-bot@canonical.com>  Thu, 26 Nov 2015 07:32:48 +0000

=== debian/control ===
--- 
+++ 
@@ -1,3 +1,8 @@
+# This file is autogenerated. DO NOT EDIT!
+#
+# Modifications should be made to control.in instead.
+# This file is regenerated automatically in the clean target.
+#
 Source: trust-store
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
@@ -7,17 +12,21 @@
                google-mock,
                graphviz,
                libapparmor-dev,
+               libboost-filesystem-dev,
                libboost-program-options-dev,
                libboost-system-dev,
+               libboost-test-dev,
                libdbus-cpp-dev (>= 4.0.0),
                libdbus-1-dev,
                libgflags-dev,
+               libglib2.0-dev,
                libgoogle-glog-dev,
                libgtest-dev,
                libjson-c-dev,
                libmirclient-dev [amd64 arm64 i386 armhf],
                libprocess-cpp-dev,
                libsqlite3-dev,
+               lsb-release,
                pkg-config,
                qt5-default,
                qtbase5-dev,

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,18 @@
 export DPKG_GENSYMBOLS_CHECK_LEVEL=4
 
 include /usr/share/dpkg/default.mk
+
+distro=$(shell lsb_release -c -s)
+
+ifeq ($(distro),vivid)
+	full_version=$(shell cat $(CURDIR)/debian/VERSION.vivid)
+else
+	full_version=$(shell cat $(CURDIR)/debian/VERSION)
+endif
+
+major=$(shell echo $(full_version) | cut -d'.' -f1)
+minor=$(shell echo $(full_version) | cut -d'.' -f2)
+patch=$(shell echo $(full_version) | cut -d'.' -f3)
 
 # Mir is an optional build dependency
 ifneq (,$(filter $(DEB_HOST_ARCH),amd64 arm64 i386 armhf))
@@ -19,4 +31,8 @@
 	dh $@ --fail-missing
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DTRUST_STORE_MIR_AGENT_ENABLED=$(TRUST_STORE_MIR_AGENT_ENABLED)
+	dh_auto_configure -- -DTRUST_STORE_MIR_AGENT_ENABLED=$(TRUST_STORE_MIR_AGENT_ENABLED) -DTRUST_STORE_VERSION_MAJOR=$(major) -DTRUST_STORE_VERSION_MINOR=$(minor) -DTRUST_STORE_VERSION_PATCH=$(patch)
+
+override_dh_auto_clean:
+	/bin/sh $(CURDIR)/debian/gen-debian-files.sh $(CURDIR)/debian
+	dh_auto_clean
